<template>
  <popup ref="popup" @close="$emit('close')">
    <div class="contact-panel">
      <div class="content">
        <div class="close-button">
          <close-button @click="() => $refs.popup && $refs.popup.close()" />
        </div>
        <div class="panel-title">{{ $t("preorderContact.title") }}</div>

        <div class="section">
          <div class="section-title">
            {{ $t("preorderContact.detailTitle") }}
          </div>
          <div class="order-info">
            <div class="order-info-field">
              <div class="order-info-field-name">
                {{ $t("preorderContact.restaurant") }}
              </div>
              <div class="order-info-field-value">
                {{ order.RestaurantName }}
              </div>
            </div>
            <div class="order-info-field">
              <div class="order-info-field-name">
                {{ $t("preorderContact.time") }}
              </div>
              <div class="order-info-field-value">
                {{ reservationTime.format("MM/DD HH:mm") }}
              </div>
            </div>
            <div class="order-info-field">
              <div class="order-info-field-name">
                {{ $t("preorderContact.number") }}
              </div>
              <div class="order-info-field-value">
                {{ last6Char(order.OrderId) }}
              </div>
            </div>
            <div class="order-info-field">
              <div class="order-info-field-name">
                {{ $t("preorderContact.status") }}
              </div>
              <div class="order-info-field-value">
                <status :order="order" />
                <!-- <div v-if="isCancelled">
                  {{ $t("preorderContact.cancelledDesc") }}
                </div> -->
              </div>
            </div>
          </div>
        </div>

        <div class="section">
          <div class="section-title">{{ $t("preorderContact.email") }}</div>
          <input
            class="email-input"
            type="email"
            :placeholder="$t('preorderContact.emailPlaceholder')"
            v-model="email"
          />
        </div>

        <div class="section">
          <div class="section-title">{{ $t("preorderContact.content") }}</div>
          <textarea
            class="content-input"
            :placeholder="$t('preorderContact.contentPlaceholder')"
            v-model="content"
          ></textarea>
          <div class="desc">{{ $t("preorderContact.desc") }}</div>
        </div>

        <button
          class="submit-button"
          :disabled="processing || invalid"
          @click="submit"
        >
          {{ $t("preorderContact.submit") }}
        </button>
      </div>
    </div>
  </popup>
</template>

<script>
import moment from "moment";
import Popup from "../Popup";
import Status from "./Status";
import { mapState } from "vuex";
import * as Api from "@/api";
import CloseButton from "@/components/CloseButton";
import { STATUS_CANCELED_BY_CUSTOMER } from "@/models/preorder";
import { last6Char } from "@/utils";

export default {
  components: {
    Popup,
    Status,
    CloseButton
  },

  props: {
    order: {
      type: Object
    }
  },

  data() {
    return {
      email: "",
      content: "",
      processing: false
    };
  },

  computed: {
    ...mapState("restaurant", ["restaurant"]),
    ...mapState("account", ["account"]),

    // NOTE: 已經沒有狀態碼這東西，表示也沒有退款中的狀態文字，皆由後端自己控制
    // isCancelled() {
    //   return this.order.OrderStauts;
    // },

    reservationTime() {
      return moment(this.order.EsDeliveryTime);
    },

    invalid() {
      return !/^.+@.+$/.test(this.email) || !this.content;
    }
  },

  methods: {
    last6Char,
    submit(data) {
      this.processing = true;
      const { id, name } = this.account;
      Api.Order.contact(this.order.OrderId, this.email, this.content, id, name)
        .then(() => {
          this.processing = false;
          this.$emit("success");
        })
        .catch(() => {
          this.processing = false;
        });
    },

    trackOpen() {
      window.gtag("event", "Customer service - start", {
        event_label: JSON.stringify({
          ...(this.restaurant && this.restaurant.dataForMixpanel
            ? this.restaurant.dataForMixpanel
            : {}),
          orderId: this.order.OrderId
        })
      });
    },

    trackSend() {
      window.gtag("event", "Customer service - send", {
        event_label: JSON.stringify({
          ...(this.restaurant && this.restaurant.dataForMixpanel
            ? this.restaurant.dataForMixpanel
            : {}),
          orderId: this.order.OrderId
        })
      });
    }
  },

  mounted() {
    this.trackOpen();
  }
};
</script>

<style lang="scss" scoped>
.contact-panel {
  position: relative;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  margin: 0 auto;
  user-select: none;
  text-align: center;
  box-sizing: border-box;

  @include media-breakpoint-up(md) {
    &::after {
      content: "";
      display: inline-block;
      height: 100%;
      width: 0;
      vertical-align: middle;
    }
  }
}

.content {
  position: absolute;
  left: 0;
  top: 0;
  right: 0;
  bottom: 0;
  background: $color-white;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);
  box-sizing: border-box;
  overflow-y: scroll;
  text-align: left;
  padding: 20px;

  @include media-breakpoint-up(md) {
    display: inline-block;
    width: 540px;
    position: relative;
    vertical-align: middle;
    max-height: 90vh;
    padding: 30px;
  }
}

.panel-title {
  font-size: 24px;
  line-height: 36px;
  font-weight: 500;
  text-align: center;
  margin-bottom: 20px;
}

.close-button {
  position: absolute;
  z-index: 1;
  top: 10px;
  right: 10px;
  width: 32px;
  height: 32px;
  vertical-align: middle;

  @include media-breakpoint-up(md) {
    top: 20px;
    right: 20px;
  }
}

.section {
  margin-bottom: 21px;
}

.section-title {
  margin-bottom: 10px;
  font-size: 14px;
  font-weight: normal;
  color: #20232b;
}

.order-info {
  padding: 15px;
  background: #f3f4f5;
  font-size: 13px;
  color: #4f5564;
}

.order-info-field {
  margin-bottom: 10px;
  display: flex;

  &:last-child {
    margin-bottom: 0;
  }
}

.order-info-field-name,
.order-info-field-value {
  flex: 1;
  white-space: nowrap;
}

.order-info-field-value {
  text-align: right;
}

.email-input {
  width: 100%;
  height: 40px;
  font-size: 16px;
  line-height: 40px;
  border-radius: 2px;
  border: solid 0.5px #9da6b9;
  box-sizing: border-box;
  padding: 0 20px;
  color: #20232b;

  &::placeholder {
    color: #cad1dd;
  }
}

.content-input {
  width: 100%;
  height: 109px;
  font-size: 16px;
  border-radius: 2px;
  border: solid 0.5px #9da6b9;
  box-sizing: border-box;
  padding: 10px 20px;
  margin-bottom: 10px;
  color: #20232b;

  &::placeholder {
    color: #cad1dd;
  }
}

.desc {
  color: #70778b;
  font-size: 13px;
}

.submit-button {
  display: block;
  width: 255px;
  height: 48px;
  border-radius: 2px;
  background-color: #de0716;
  margin: 40px auto;
  border: none;
  color: #ffffff;
  font-size: 16px;
  cursor: pointer;

  &:disabled {
    cursor: default;
    background-color: #cad1dd;
  }

  @include media-breakpoint-up(md) {
    margin-bottom: 0;
    width: 315px;
  }
}
</style>
